; 

      .486
      .model flat, stdcall
      option casemap :none

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc

      ; include automat.inc

include \masm32\include\debug.inc

; -------------------------------------------------------------------------
      include xmlparser.inc
; -------------------------------------------------------------------------

      include resource\resource.inc

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

      ; includelib automat.lib

 includelib \masm32\lib\debug.lib

; -------------------------------------------------------------------------
      includelib xmlparser.lib
; -------------------------------------------------------------------------

; 


	ID_EDITBOX		EQU 100
	BUFFER_SIZE		EQU 1000h		; buffer 4kB


; 

    .data?
	
	hInstance		dd ?
	CommandLine		dd ?
	
	ofn			OPENFILENAME <>

	hMainWnd		dd ?
	hFnt			dd ?
	hEditBox			dd ?

	lpBuffer			dd ?
	hEditBuffer		dd ?

	MyXMLParser		dd ?
	
; 

    .data

	szMainClassName		db 'MainWinClass',0
	szMainName		db 'XML parser',0

	szErrorCaption		db 'Message...',0
	
	szAboutCaption		db 'XML parser',0

	szEditCtrlClass		db 'EDIT',0

	Rect			RECT <>

	fileFilter			db "XML documents",0,"*.xml",0
				db "all files",0,"*.*",0,0

	szFileName		db 260 dup (0)
	hFile			dd 0
	dwBytesRead		dd 0


	szEditBoxError1		db 'Error creating Edit Control!',0
	
	szFileError1		db 'File open error!',0
	szFileError2		db 'File read error!',0
	
	
	
	counter			dd ?
	dumyFileName		db 'test.xml',0

; 


	include xml.asm


; 

    .code
    
	Dumy1		PROTO

	WinMain		PROTO :DWORD,:DWORD,:DWORD,:DWORD
	WndProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD
	CreateEditBox	PROTO
	TopXY		PROTO :DWORD,:DWORD

	ProcessInput	PROTO
	FetchFile		PROTO :DWORD,:DWORD

	include functions.asm

; 

start:

		invoke GetModuleHandle,NULL
		mov     hInstance,eax

		invoke GetCommandLine
		mov     CommandLine,eax

 		invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT

		invoke ExitProcess,eax


; 
; 
comment &
Dumy1		PROC

		invoke XML_resetParser,MyXMLParser
		jnc @1
			invoke XML_error,MyXMLParser
			jmp @3
@1:
		invoke CreateFile,addr dumyFileName,GENERIC_READ,NULL,NULL,OPEN_EXISTING,NULL,NULL
		or	eax,eax
		jnz @2
		mov	eax,offset szFileError1
		jmp @3
@2:
		mov	hFile,eax
		invoke ProcessFile
		push	eax
		invoke CloseHandle,hFile
		pop	eax
@3:
		ret
Dumy1		ENDP
&
; 
; 


; 

WinMain		PROC hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

LOCAL wc:WNDCLASSEX
LOCAL msg1:MSG
LOCAL Wwd:DWORD
LOCAL Wht:DWORD
LOCAL Wtx:DWORD
LOCAL Wty:DWORD

;==================================================
; Fill WNDCLASSEX structure with required variables
;==================================================
		mov	wc.cbSize,sizeof WNDCLASSEX
		mov	wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
		mov	wc.lpfnWndProc,offset MainWndProc
		mov	wc.cbClsExtra,NULL
		mov	wc.cbWndExtra,NULL
		m2m	wc.hInstance,hInst
		mov	wc.hbrBackground,COLOR_BTNFACE+1
		mov	wc.lpszMenuName,NULL
		mov	wc.lpszClassName,offset szMainClassName
		invoke LoadIcon,hInst,500
		mov	wc.hIcon,eax
		invoke LoadCursor,NULL,IDC_ARROW
		mov	wc.hCursor,eax
		mov	wc.hIconSm,0

		invoke RegisterClassEx,ADDR wc

;================================
; Centre window at following size
;================================
		mov	Wwd,500
		mov	Wht,350
		invoke GetSystemMetrics,SM_CXSCREEN
		invoke TopXY,Wwd,eax
		mov	Wtx,eax
		invoke GetSystemMetrics,SM_CYSCREEN
		invoke TopXY,Wht,eax
		mov	Wty,eax
; ==================================
; Create the main application window
; ==================================
		invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,
			ADDR szMainClassName,
			ADDR szMainName,
			WS_OVERLAPPEDWINDOW,
			Wtx,Wty,Wwd,Wht,
			NULL,NULL,
			hInst,NULL
		or	eax,eax
		jz ExitLoop
		mov	hMainWnd,eax

		invoke LoadMenu,hInst,600
		invoke SetMenu,hMainWnd,eax

		invoke ShowWindow,hMainWnd,SW_SHOWNORMAL
		invoke UpdateWindow,hMainWnd

;===================================
; Loop until PostQuitMessage is sent
;===================================
StartLoop:
		invoke GetMessage,ADDR msg1,NULL,0,0
		or	eax,eax
		jz ExitLoop
		invoke TranslateMessage,ADDR msg1
		invoke DispatchMessage,ADDR msg1
		jmp StartLoop
ExitLoop:
		mov	eax,msg1.wParam
		ret
WinMain		ENDP

; 
;
; Main window procedure
;
; 

MainWndProc	PROC hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

		mov	 eax,uMsg
; ======== WM_COMMAND =========
		cmp	eax,WM_COMMAND
		jnz @WM_CREATE
			mov	eax,wParam
; ======== 
@IDQUIT:
			cmp	eax,IDQUIT
			jnz @IDOPEN
				invoke PostMessage,hMainWnd,WM_CLOSE,NULL,NULL
				xor	eax,eax
				jmp @END
; ======== 
@IDOPEN:
			cmp	eax,IDOPEN
			jnz @IDABOUT

				invoke Open
				; if eax is
				; 0 - open successful
				; 1 - user canceled
				; other - error
				cmp	eax,1
				jnz @IDOPEN1
				or	eax,eax
				jnz @END
@IDOPEN1:
				or	eax,eax
				jnz @Error
				invoke XML_resetParser,MyXMLParser
				jnc @IDOPEN2
					invoke XML_error,MyXMLParser
					jmp @Error
@IDOPEN2:
				invoke SendMessage,hEditBox,EM_SETSEL,0,-1
				invoke SendMessage,hEditBox,WM_CLEAR,0,0

				invoke ProcessFile
			; eax is NULL no error
			; eax is not NULL address of errortext
				push	eax
				invoke CloseHandle,hFile
				pop	eax

				or	eax,eax
				jnz @Error
				jmp @END
; ======== 
@IDABOUT:
			cmp	eax,IDABOUT
			jnz @DEFAULT
				invoke MessageBox,hMainWnd,ADDR szAboutCaption,ADDR szMainName,MB_OK
				xor	eax,eax
				jmp @END
; ========= WM_CREATE =========
@WM_CREATE:
		cmp	eax,WM_CREATE
		jnz @WM_CLOSE
			m2m	hMainWnd,hWin
			invoke CreateMain
			or 	eax,eax
			jnz @Error

			invoke CreateEditBox
			or	eax,eax
			jz @END
			jmp @Error
; ========== WM_CLOSE =========
@WM_CLOSE:
		cmp	eax,WM_CLOSE
		jnz @WM_SIZE
			invoke DestroyMain
			invoke DestroyWindow,hMainWnd
			xor	eax,eax
			jmp @END
; ========= WM_SIZE ===========
@WM_SIZE:
		cmp	eax,WM_SIZE
		jnz @WM_DESTROY
			invoke GetClientRect,hMainWnd,addr Rect
			mov	eax,Rect.left
			sub	Rect.right,eax
			mov	eax,Rect.top
			sub	Rect.bottom,eax
			invoke MoveWindow,hEditBox,0,0,Rect.right,Rect.bottom,TRUE
			xor	eax,eax
			jmp @END
; ======== WM_DESTROY =========
@WM_DESTROY:
		cmp	eax,WM_DESTROY
		jnz @DEFAULT
			invoke PostQuitMessage,NULL
			xor	eax,eax
			jmp @END
; ========= DEFAULT ===========
@DEFAULT:
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
@END:
		ret
; =============
@Error:
		invoke MessageBox,hMainWnd,eax,offset szErrorCaption,MB_OK
		xor	eax,eax
		jmp @END

MainWndProc	ENDP

; 

end start
